﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls


Partial Class ImageUpload
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        If IsPostBack = True And FileUpload1.HasFile = True And CheckBox1.Checked = True Then
            Dim rootWebConfig As System.Configuration.Configuration = _
                System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("~/Final")
            Dim myConnString As String = _
                rootWebConfig.ConnectionStrings.ConnectionStrings("ConnectionString").ToString()
            Dim myConn As SqlConnection = New SqlConnection(myConnString)
            myConn.Open()
            ' Begin transaction here
            Dim myTrans As SqlTransaction = myConn.BeginTransaction()

            Dim imageID As Integer = 0
            Try
                Dim myQuery As SqlCommand = New SqlCommand("SELECT claimID FROM claim WHERE reference=@reference", myConn)
                myQuery.Transaction = myTrans
                myQuery.Parameters.AddWithValue("@reference", TextBox1.Text)
                Dim myDr As SqlDataReader
                myDr = myQuery.ExecuteReader()
                If myDr.Read() = False Then
                    Label1.Text = "Invalid claim reference"
                    Return
                End If
                Dim claimID As Integer = myDr.GetInt32(0)
                myDr.Close()

                Dim myInsert As SqlCommand = New SqlCommand("INSERT INTO image VALUES(@title,@description,@claimID)", myConn)
                myInsert.Transaction = myTrans
                myInsert.Parameters.AddWithValue("@title", TextBox2.Text)
                myInsert.Parameters.AddWithValue("@description", TextBox3.Text)
                myInsert.Parameters.AddWithValue("@claimID", claimID)
                Dim rows As Integer = myInsert.ExecuteNonQuery()
                If rows <> 1 Then
                    Throw New Exception("Unexpected Result for Insert")
                End If

                Dim myCount As SqlCommand = New SqlCommand("SELECT MAX(imageID) AS IMAGEID FROM image", myConn)
                myCount.Transaction = myTrans
                myDr = myCount.ExecuteReader()
                myDr.Read()
                imageID = myDr.GetInt32(0)
                myDr.Close()
                ' Close transaction here -- success
                myTrans.Commit()
            Catch myEx As Exception
                ' Close transaction here -- failure
                myTrans.Rollback()
            End Try
            ' Note that the upload itself should also be included in the scope
            ' of the transaction -- but this is not possible -- as the file
            ' system does not support this
            Dim path As String = Server.MapPath("~/Uploads/")
            Try
                Dim fileName As String = path + imageID.ToString() + ".jpg"
                FileUpload1.PostedFile.SaveAs(fileName)
                ' Create thumbnail as well
                Dim fullImage As System.Drawing.Image = System.Drawing.Image.FromFile(fileName)
                Dim thumb As System.Drawing.Image = New System.Drawing.Bitmap(fullImage, 100, 100)
                Dim thumbName As String = path + "thumb" + imageID.ToString() + ".jpg"
                thumb.Save(thumbName, fullImage.RawFormat)
                ' Assume save was successful
                Label1.Text = "Upload successful"
            Catch myEx As Exception
                Label1.Text = "Upload failed"
            End Try
        End If
    End Sub

End Class
